//+------------------------------------------------------------------+
//|                                              Phoenix_5_7_F.mq4   |
//|                                       Copyright  2006, Hendrick |
//|               Joint Copyright  2006 PhoenixFund Community       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Hendrick."

#define MAGICMA_A  20061120   //modified to simple range by Daraknor 5.6.6
#define MAGICMA_B  20061121   //If you run two copies of Phoenix on one account, modify Magic numbers on one EA.

#define MAGICMA01  20061122
#define MAGICMA02  20061123
#define MAGICMA03  20061124

//+--------------------------------------------------------------------------------------------------+
//|  Fields that start with U_ - are USER fields - that the user always chooses.
//|                            - contain defaults that are the same for all currencies.
//|                            - You must set these, even if you set PrefSettings to True
//|
//|                         P  - If you set PrefSettings to False then you need to set all the
//|                              external fields  starting with P_ and U_ to your own settings.
//|
//|                         C  - These are just comments
//+--------------------------------------------------------------------------------------------------+

extern string     C_INIT                     = "=== Use INIT section - ignore all P_ settings =====";
extern bool       U_PrefSettings             = true;     //True means the builtin values are used to trade

extern string     C_PhoenixSettings          = "===== Phoenix Mode Selected ==============================";
extern int        U_PhoenixModeSelected      = 1;	//Changed by Daraknor 5.6.8 to mode 1 by default for stable trading 5.6.8

extern string     C_Mode1                    = "====== Phoenix Mode 1 (Stable) ==================";
extern int        U_Mode1_BreakEvenAfterPips = 0;
extern int        P_Mode1_TrailingStop       = 0;	//set here to activate trailing stop, value of 0 disables.

extern string     C_Mode12_Settings          = "==== Phoenix Mode 1 & 2 - shared fields ==================";
extern int        P_Mode12_TakeProfit        = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern int        P_Mode12_StopLoss          = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern int        U_Mode12_MaxTrades         = 1;	//set to number of trades to open
extern int        U_Mode12_ConsecutiveSignals= 5;	//Set to number of consecutive confirming signals.
                                                   //Added 5.6.4 by Daraknor, contributed by Dagnar
                                                   //Change 5.6.6 by Daraknor to default setting of 5 for consistency in trading

extern string     C_Mode2                    = "===== Phoenix Mode 2 (2 trades-testing, move 2nd SL)===";
extern int        P_Mode2_OpenTrade_2        = 0;
extern int        P_Mode2_TakeProfit         = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern int        P_Mode2_StopLoss           = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern bool       U_Mode2_CloseFirstTrade    = false;

extern string     C_Mode3                    = "====== Phoenix Mode 3 (3 trades-testing, moving SL, incr profit) =====";
extern int        P_Mode3_CloseTrade2_3      = 0;
extern int        P_Mode3_TakeProfit         = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern int        P_Mode3_StopLoss           = 0;	//not necessary for standard currencies, assign here for U_PrefSettings=false
extern double     P_Mode3_T1adj              = 0.8;
extern double     P_Mode3_T2adj              = 1.0;
extern double     P_Mode3_T3adj              = 1.2; 	//Added 5.7.0

// Y Monday Management Settings

extern string     C_Function_Y               = "====== U_MoneyManagement decreases lotsize in a losing streak =====";
extern bool       U_MoneyManagement          = true;     //Money management
extern double     U_Lots                     = 1;        //Money management will override setting
extern double     U_MaximumRisk              = 0.05;     //
extern int        U_DecreaseFactor           = 0;        //
extern bool       U_AccountIsMicro           = false;	 //Micro means 0.01 lot size is allowed

extern string     C_Function_X               = "====== Grace Functionality ======";
extern int        U_PeriodGraceHours         = 0;       //Setting of 0 disables, 24 = 24 hours Daraknor 5.6.6
extern int        U_PeriodForceHours         = 0;       //Setting of 0 disables, 48 = 48 hours Darankor 5.6.6

//extern string     C_Function_X               = "====== Ensure your trades close with x hours ======";
//extern int        U_CloseAfter_x_Hours       = 0;   //Disabled in 5.6.6 by Daraknor, switching to Grace/Force


extern string     C_Signal1                  = "====== Signal 1 ===================================";
extern bool       U_UseSignal1               = true;
extern double     P_Percent                  = 0;
extern int        P_EnvelopePeriod           = 0;

extern string     C_Signal2                  = "====== Signal 2 ==================================";
extern bool       U_UseSignal2               = true;
extern int        P_SMAPeriod                = 0;
extern int        P_SMA2Bars                 = 0;

extern string     C_Signal3                  = "====== Signal 3 ==================================";
extern bool       U_UseSignal3               = true;
extern int        P_OSMAFast                 = 0;
extern int        P_OSMASlow                 = 0;
extern double     P_OSMASignal               = 0;

extern string     C_Signal4                  = "====== Signal 4 ==================================";
extern bool       U_UseSignal4               = true;
extern int        P_Fast_Period              = 0;
extern int        P_Fast_Price               = PRICE_OPEN;
extern int        P_Slow_Period              = 0;
extern int        P_Slow_Price               = PRICE_OPEN;
extern double     P_DVBuySell                = 0;
extern double     P_DVStayOut                = 0;

extern string     C_Signal5                  = "====== Signal 5 =================================";
extern bool       U_UseSignal5               = true;
extern int        U_TradeFrom1               = 0;
extern int        U_TradeUntil1              = 24;
extern int        U_TradeFrom2               = 0;
extern int        U_TradeUntil2              = 0;
extern int        U_TradeFrom3               = 0;
extern int        U_TradeUntil3              = 0;
extern int        U_TradeFrom4               = 0;
extern int        U_TradeUntil4              = 0;

//+--------------------------------------------------------------------------------------------------+
//|  Fields that start with W_ - are WORK fields - You don't change these.                           |
//+--------------------------------------------------------------------------------------------------+

int W_Buy_Signal=0;			//confirming signals code   Added 5.6.4
int W_Sell_Signal=0;
int W_s_time=0;


//+------------------------------------------------------------------+
//| INITIALIZATION SECTION                                           |
//+------------------------------------------------------------------+

int init()
{
GlobalVariableSet("FlagMode3Trade2",1);	//fixed mode3 code
GlobalVariableSet("FlagMode3Trade3",1);	//fixed mode3 code


//+------------------------------------------------------------------+
//| START Preffered Settings                                         |
//+------------------------------------------------------------------+
if(U_PrefSettings == true)
   {
   if((Symbol() == "EURUSD") || (Symbol() == "EURUSDm"))
      {     //Settings added in 5.6.6 by Daraknor, contributed by EricBach
            //Modified ????? after testing.

      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 10;
      P_Mode12_StopLoss      = 10;

      P_Mode2_OpenTrade_2    = 0;
      P_Mode2_TakeProfit     = 50;
      P_Mode2_StopLoss       = 60;


      P_Mode3_CloseTrade2_3  = 0;
      P_Mode3_TakeProfit     = 42;
      P_Mode3_StopLoss       = 84;

      // Signal 1 to 4 Settings

      P_Percent              = 0.001;
      P_EnvelopePeriod       = 20;

      P_SMAPeriod            = 11;
      P_SMA2Bars             = 50;

      P_OSMAFast             = 8;
      P_OSMASlow             = 40;
      P_OSMASignal           = 10;

      P_Fast_Period          = 4;
      P_Slow_Period          = 15;
      P_DVBuySell            = 0.0003;
      P_DVStayOut            = 0.006;

      }
   if((Symbol() == "USDJPY") || (Symbol() == "USDJPYm"))
      {
      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;

      P_Mode2_OpenTrade_2    = 0;
      P_Mode2_TakeProfit     = 50;
      P_Mode2_StopLoss       = 60;


      P_Mode3_CloseTrade2_3  = 0;
      P_Mode3_TakeProfit     = 42;
      P_Mode3_StopLoss       = 84;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0032;
      P_EnvelopePeriod       = 2;

      P_SMAPeriod            = 2;
      P_SMA2Bars             = 18;

      P_OSMAFast             = 5;
      P_OSMASlow             = 22;
      P_OSMASignal           = 2;

      P_Fast_Period          = 25;
      P_Slow_Period          = 15;
      P_DVBuySell            = 0.0029;
      P_DVStayOut            = 0.024;
      }

   if((Symbol() == "EURJPY") || (Symbol() == "EURJPYm"))
      {
      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;

      P_Mode2_OpenTrade_2    = 18;
      P_Mode2_TakeProfit     = 70;
      P_Mode2_StopLoss       = 30;

      P_Mode3_CloseTrade2_3  = 55;
      P_Mode3_TakeProfit     = 70;
      P_Mode3_StopLoss       = 80;

      // Signal 1 to 4 Settings

      P_Percent              = 0.007;
      P_EnvelopePeriod       = 2;

      P_SMAPeriod            = 4;
      P_SMA2Bars             = 16;

      P_OSMAFast             = 11;
      P_OSMASlow             = 20;
      P_OSMASignal           = 14;

      P_Fast_Period          = 20;
      P_Slow_Period          = 10;
      P_DVBuySell            = 0.0078;
      P_DVStayOut            = 0.026;
      }

   if((Symbol() == "GBPJPY") || (Symbol() == "GBPJPYm"))
      {
      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;

      P_Mode2_OpenTrade_2    = 2;
      P_Mode2_TakeProfit     = 130;
      P_Mode2_StopLoss       = 80;


      P_Mode3_CloseTrade2_3  = 40;
      P_Mode3_TakeProfit     = 90;
      P_Mode3_StopLoss       = 80;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0072;
      P_EnvelopePeriod       = 2;

      P_SMAPeriod            = 8;
      P_SMA2Bars             = 12;

      P_OSMAFast             = 5;
      P_OSMASlow             = 36;
      P_OSMASignal           = 10;

      P_Fast_Period          = 17;
      P_Slow_Period          = 28;
      P_DVBuySell            = 0.0034;
      P_DVStayOut            = 0.063;
      }

   if((Symbol() == "USDCHF") || (Symbol() == "USDCHFm"))
      {
      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;

      P_Mode2_OpenTrade_2    = 10;
      P_Mode2_TakeProfit     = 90;
      P_Mode2_StopLoss       = 65;


      P_Mode3_CloseTrade2_3  = 85;
      P_Mode3_TakeProfit     = 130;
      P_Mode3_StopLoss       = 80;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0056;
      P_EnvelopePeriod       = 10;

      P_SMAPeriod            = 5;
      P_SMA2Bars             = 9;

      P_OSMAFast             = 5;
      P_OSMASlow             = 12;
      P_OSMASignal           = 11;

      P_Fast_Period          = 5;
      P_Slow_Period          = 20;
      P_DVBuySell            = 0.00022;
      P_DVStayOut            = 0.0015;
      }

   if((Symbol() == "GBPUSD") || (Symbol() == "GBPUSDm"))
      {
      P_Mode1_TrailingStop   = 0;    //  Also used in the X_ForceClose_or_GraceModify function

      P_Mode12_TakeProfit    = 42;
      P_Mode12_StopLoss      = 84;

      P_Mode2_OpenTrade_2    = 5;
      P_Mode2_TakeProfit     = 95;
      P_Mode2_StopLoss       = 90;


      P_Mode3_CloseTrade2_3  = 90;
      P_Mode3_TakeProfit     = 110;
      P_Mode3_StopLoss       = 80;

      // Signal 1 to 4 Settings

      P_Percent              = 0.0023;
      P_EnvelopePeriod       = 6;

      P_SMAPeriod            = 3;
      P_SMA2Bars             = 14;

      P_OSMAFast             = 23;
      P_OSMASlow             = 17;
      P_OSMASignal           = 15;

      P_Fast_Period          = 25;
      P_Slow_Period          = 37;
      P_DVBuySell            = 0.00042;
      P_DVStayOut            = 0.05;
      }
   }
return(0);
}

//+------------------------------------------------------------------+
//| END Preffered Settings                                           |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START EA  -  MainlIne                                            |
//+------------------------------------------------------------------+
void start()
   {
   if(Bars<100)
      {
      Print("bars less than 100");
      return(0);
      }

//   if(U_PhoenixModeSelected==1)//Phoenix Classic
//      {
//      S1_Mode_1_2_OpenTrade_If_Signal();                                     //  same
//      if(U_CloseAfter_x_Hours != 0)        X_Close_After_x_Hours();          //Disabled in favor of grace/force 5.6.6 Daraknor
//      if(!P_Mode12_StopLoss==0)            M1_A_UpdateTStop_if_Applicable(); //StopLoss changed to Trailing Stop
//                                                                             // Added 5.6.6 by Daraknor, submitted by Denkhaus.
//                                                                             //Restore previous behavior by switching out
//                                                                             // P_Mode12_StopLoss for P_Mode1_TrailingStop
//      if(U_Mode1_BreakEvenAfterPips != 0)  M1_B_Update_TStop_if_BreakEven();  //  same
//      }

   if(U_PhoenixModeSelected==1)//Phoenix Classic - Open One Trade
      {
      S1_Mode_1_2_OpenTrade_If_Signal();
      if(U_PeriodGraceHours !=0 ||U_PeriodForceHours !=0) X_ForceClose_or_GraceModify();

      if(P_Mode1_TrailingStop !=0)              M1_A_Update_TStop_if_Applicable();
      if(U_Mode1_BreakEvenAfterPips != 0)       M1_B_Update_TStop_if_BreakEven();
      }


   if(U_PhoenixModeSelected==2)//Phoenix - Open Second Trade after First Trade Profit
      {
      S1_Mode_1_2_OpenTrade_If_Signal();

//    if(U_CloseAfter_x_Hours != 0)  CheckU_CloseAfter_x_Hours();//Disabled in favor of grace/force 5.6.6 Daraknor

      if(U_PeriodGraceHours !=0 ||U_PeriodForceHours !=0) X_ForceClose_or_GraceModify();
      M2_A_MakeSecondTrade_If_Profit();
      }

   if(U_PhoenixModeSelected==3)//Phoenix 123 - Open three trades at once
      {
      if(U_PeriodGraceHours !=0 ||U_PeriodForceHours !=0) X_ForceClose_or_GraceModify();//Added 5.6.6 Daraknor

      M3_A_Mode3_OpenTrade_If_Signal();
      M3_B_MoveSL_Trade_2_3_to_CurPr();
      M3_C_MoveSL_Trade_3_to_CalcPr();
      if(P_Mode3_CloseTrade2_3 != 0) M3_D_CloseTrade23_If_Trd1_Loss();
      }
   }
//+------------------------------------------------------------------+
//| END EA   - End Mainline                                          |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+-------------  MODE 1 Functions ----------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function UpdateTStop_if_Applicable   - Mode 1              |
//+------------------------------------------------------------------+

void M1_A_Update_TStop_if_Applicable()
   {
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;

      if(OrderType() == OP_BUY)
         {
         if(((Bid - OrderOpenPrice()) > (Point * P_Mode1_TrailingStop)) && (OrderStopLoss() < (Bid - Point * P_Mode1_TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Bid - Point * P_Mode1_TrailingStop,
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }

      if(OrderType() == OP_SELL)
         {
         if(((OrderOpenPrice() - Ask) > (Point * P_Mode1_TrailingStop)) && (OrderStopLoss() > (Ask + Point * P_Mode1_TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Ask + Point * P_Mode1_TrailingStop,
                        OrderTakeProfit(),
                        0,
                        Red);
         }
      }
   }

//+------------------------------------------------------------------+
//| START Function UpdateTStop_if_BreakEven  - Mode 1                |
//+------------------------------------------------------------------+
void M1_B_Update_TStop_if_BreakEven()
   {
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;

      if(OrderType() == OP_BUY)
         {
         if((Bid-OrderOpenPrice()) > (Point*U_Mode1_BreakEvenAfterPips))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        OrderOpenPrice(),
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }

      if(OrderType() == OP_SELL)
         {
         if((OrderOpenPrice()-Ask) > (Point*U_Mode1_BreakEvenAfterPips))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        OrderOpenPrice(),
                        OrderTakeProfit(),
                        0,
                        Red);
         }
      }
   }

//+------------------------------------------------------------------+
//+-------------  MODE 2 Functions ----------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function MakeSecondTrade_If_Profit  - Mode 2               |
//+------------------------------------------------------------------+
void M2_A_MakeSecondTrade_If_Profit()
   {
   int err = 0, total = OrdersTotal();

   for(int z = total - 1; z >= 0; z --)
      {
      if(!OrderSelect( z, SELECT_BY_POS))
         {
         err = GetLastError();
         Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #",err );
         continue;
         }

      if(OrderSymbol() != Symbol())       continue;

      if(OrderMagicNumber() == MAGICMA_B) break;

      if(OrderMagicNumber() != MAGICMA_A) continue;

      if(OrderType() == OP_BUY && (Bid-OrderOpenPrice() > Point*P_Mode2_OpenTrade_2))
         {
         if(OrderSend(Symbol(),OP_BUY,Y_MM_OptimizeLotSize(),Ask,3,Ask - P_Mode2_StopLoss * Point,Ask + P_Mode2_TakeProfit * Point,"Mode2_SecondTrade",MAGICMA_B,0,Blue) < 0)
            {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
         if(U_Mode2_CloseFirstTrade==true) {M2_A_1_CloseFirstTrade();}
         return(0);
         }

      if(OrderType() == OP_SELL && (OrderOpenPrice()-Ask > Point*P_Mode2_OpenTrade_2))
         {
         if(OrderSend(Symbol(),OP_SELL,Y_MM_OptimizeLotSize(),Bid,3,Bid + P_Mode2_StopLoss * Point,Bid - P_Mode2_TakeProfit*Point,"Mode2_SecondTrade",MAGICMA_B,0,Red) < 0)
            {
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
         if(U_Mode2_CloseFirstTrade==true) {M2_A_1_CloseFirstTrade();}
         return(0);
         }
      }
   }

//+------------------------------------------------------------------+
//| START Function Close First Trade - Mode 2                        |
//+------------------------------------------------------------------+
int M2_A_1_CloseFirstTrade()
   {
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)          break;
      if(OrderMagicNumber()!=MAGICMA_A || OrderSymbol()!=Symbol()) continue;

         OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
         return(0);
      }
   }


//+------------------------------------------------------------------+
//+-------------  MODE 3 Functions ----------------------------------+
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| START Function Open Trade If Signal  - MODE 3  By HerbertH 5.6.4 |
//+------------------------------------------------------------------+

int M3_A_Mode3_OpenTrade_If_Signal()
   {

   int Signal = 0, err = 0, total = OrdersTotal(), decimalPlaces=1;

   if(U_AccountIsMicro==true)                        decimalPlaces=2;

   double lots123 = NormalizeDouble(Y_MM_OptimizeLotSize()/3,decimalPlaces);

   if(lots123 < 0.1 && U_AccountIsMicro==false) {lots123=0.1;}
   if(lots123 < 0.01 && U_AccountIsMicro==true) {lots123=0.01;}

   if(M3_A_1_NumberOfOpenPositions(Symbol()) < 1)
      {
      if(Z_CheckSignal(Signal)==1)
         {
         if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T1adj,0)*Point,"Mode3_FirstTrade",MAGICMA01,0,Red)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }

         if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T2adj,0)*Point,"Mode3_SecondTrade",MAGICMA02,0,Red)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }

         if(OrderSend(Symbol(),OP_SELL,lots123,Bid,3,Bid+P_Mode3_StopLoss*Point,Bid-NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T3adj,0)*Point,"Mode3_ThirdTrade",MAGICMA03,0,Red)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
            //5.7.0      GlobalVariableSet("FlagMode3Trade2",1);
            //5.7.0      GlobalVariableSet("FlagMode3Trade3",1);
         return(0);
         }

         if(Z_CheckSignal(Signal)==2)
         {
         if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T1adj,0)*Point,"Mode3_FirstTrade",MAGICMA01,0,Blue)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
         if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T2adj,0)*Point,"Mode3_SecondTrade",MAGICMA02,0,Blue)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
         if(OrderSend(Symbol(),OP_BUY,lots123,Ask,3,Ask-P_Mode3_StopLoss*Point,Ask+NormalizeDouble(P_Mode3_TakeProfit*P_Mode3_T3adj,0)*Point,"Mode3_ThirdTrade",MAGICMA03,0,Blue)<0)
            {	//5.7.0 Set scale adj to variable
            err = GetLastError();
            Print("Error Ordersend(",err,"): ");
            return(-1);
            }
         GlobalVariableSet("FlagMode3Trade2",1);
         GlobalVariableSet("FlagMode3Trade3",1);
         return(0);
         }
      }
   }

//+------------------------------------------------------------------+
//| START Function Number of Open Positions - Mode 3                 |
//+------------------------------------------------------------------+

int M3_A_1_NumberOfOpenPositions(string symbol)
  {
    int buys=0,sells=0;

    for(int i=0;i<OrdersTotal();i++)
      {
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
        if(
           (OrderSymbol()==Symbol()) &&
           ((OrderMagicNumber()==MAGICMA01) ||
            (OrderMagicNumber()==MAGICMA02) ||
            (OrderMagicNumber()==MAGICMA03))   )
          {
            if(OrderType()==OP_BUY)  buys++;
            if(OrderType()==OP_SELL) sells++;
          }
      }
    return(buys+sells);
  }



//+------------------------------------------------------------------+
//| START Check First Trade Mode3                                    |
//+------------------------------------------------------------------+
void M3_B_MoveSL_Trade_2_3_to_CurPr()
  {//5.7.0 Removed all global variable and history references
//  bool FirstTrade=false;
//  int z; //Added 5.6.6 by Daraknor so history check isn't slower every time the system runs.
//  if(HistoryTotal()<20) z=20;    //We can't count back to negative numbers.
//  else z=HistoryTotal()-20;      //Only check last 20 trades, not entire history.
//  for(int x=HistoryTotal()-1;x>=z;x--)    //Changed 0 to z.
//    {
//      if(!OrderSelect(x,SELECT_BY_POS,MODE_HISTORY))
//        {
//          Print("OrderSelect( ", x, ", SELECT_BY_POS ) - Error #",GetLastError());
//          continue;
//      }
//      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA01)
//      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA01)
//        {   //Why Sell only? Changed 5.6.6 by Daraknor
//          if(OrderProfit()>0) FirstTrade=true;  //Undid change 5.6.7a Changed from 0 to 10 by Daraknor 5.6.7, submitted by wackena
//          break;
//        }
//    }
    if(S2_Mode_ALL_NumberOfOpenOrder(Symbol())==2)	//5.7.0 Assumes Mode3 starts with 3 tardes,has 3 trades max.
  
  //  if(FirstTrade==true && GlobalVariableGet("FlagMode3Trade2")==1)
      {
  //      RefreshRates(); //Added by Daraknor 5.6.6 //Removed by Daraknor 5.6.7
        for(int y=0;y<OrdersTotal();y++)
          {
            OrderSelect(y, SELECT_BY_POS, MODE_TRADES);
            if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()&& (OrderMagicNumber()==MAGICMA02 || OrderMagicNumber()==MAGICMA03))
   //         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()&& (OrderMagicNumber()==MAGICMA02))
              { //undid change in 5.6.7a changed 5.6.7 above line to only work on MAGICMA02
                RefreshRates(); //Added by Daraknor 5.6.7 This makes more sense here, possibly the reason there was a bug
  //		if(OrderProfit()>0) Print("Profit: ",OrderProfit());
  //			else continue;
  		if(OrderType()==OP_BUY)
                  {
  
  		   if(Ask<OrderOpenPrice()+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) continue; //5.7.0
  		   if(OrderOpenPrice()<=OrderStopLoss()) continue; //Changed 5.6.7a, Added 5.6.7 by Daraknor, if new SL = old SL then quit.
  		   if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,GreenYellow))
                        { //Modify 5.6.7 by Daraknor - previous line becomes if(!order). Added error printing below
                        Print("OrderModify 2 ",Bid," Error # ",GetLastError()); 	//Modify 5.7.0 increased logging
                        continue;
                        }
   //5.7.0                 GlobalVariableSet("FlagMode3Trade2",2);
                  }
                if(OrderType()==OP_SELL)
                  {
  		if(Bid>OrderOpenPrice()-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) continue; //5.7.0
  		if(OrderOpenPrice()>=OrderStopLoss()) continue; //Changed 5.6.7a Added 5.6.7 by Daraknor, if new SL = old SL then quit.
                    if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,GreenYellow))
                      { //Modify 5.6.7 by Daraknor - previous line becomes if(!order). Added error printing below
                        Print("OrderModify 2 ",Ask," Error # ",GetLastError()); 	//Modify 5.7.0 increased logging
                        continue;
                      }
  //5.7.0               GlobalVariableSet("FlagMode3Trade2",2);
                  }
              }
          }
      }
  }

//+------------------------------------------------------------------+
//| START Check Second Trade Mode3                                   |
//+------------------------------------------------------------------+
void M3_C_MoveSL_Trade_3_to_CalcPr()
  {//5.7.0 Removed all global variable and history references
//  int z; //Added 5.6.7 by Daraknor so history check isn't slower every time the system runs.
//  if(HistoryTotal()<20) z=20;    //We can't count back to negative numbers.
//  else z=HistoryTotal()-20;      //Only check last 20 trades, not entire history.
//  bool SecondTrade=false;
  double NewSLTrade3B,NewSLTrade3S;
//  RefreshRates(); //Added by Daraknor 5.6.6 //Disabled 5.6.7
//  for(int x=HistoryTotal()-1;x>=z;x--) //5.6.7 by Daraknor, changed 0 to z
//    {
//      if(!OrderSelect(x,SELECT_BY_POS,MODE_HISTORY))
//        {
//          Print("OrderSelect( ", x, ", SELECT_BY_POS ) - Error #",GetLastError());
//          continue;
//        }

//      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA02)
//        {
//          if(OrderProfit()>0) SecondTrade=true;//Undid change 5.6.7a Changed from 0 to 10 by Daraknor 5.6.7, submitted by wackena
//          break;     //A better value than 10 might be found. Suggestions??
//        }
//    }

//  if(SecondTrade==true && GlobalVariableGet("FlagMode3Trade3")==1)
    if(S2_Mode_ALL_NumberOfOpenOrder(Symbol())==1)	//5.7.0 Assumes Mode3 starts with 3 trades,has 3 trades max.
      {
        for(int y=0;y<OrdersTotal();y++)
          {
            OrderSelect(y, SELECT_BY_POS, MODE_TRADES);
            if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()&& OrderMagicNumber()==MAGICMA03)
              {
                if(OrderType()==OP_BUY)
                  {
                    NewSLTrade3B=OrderOpenPrice()+NormalizeDouble(((
                       OrderTakeProfit()-OrderOpenPrice())/2),Digits)- MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
                    //Added MarketInfo STOPLevel 5.6.6 by Daraknor to make the trades universally broker safe
  		//Modified 5.6.8 by Daraknor, STOPLEVEL returns Point value. Adjusted value to price with *Point
  			if(NewSLTrade3B<=OrderStopLoss()) continue; //Added 5.6.7 by Daraknor, if new SL equal or worse old SL then quit.
                    if(!OrderModify(OrderTicket(),OrderOpenPrice(),NewSLTrade3B,OrderTakeProfit(),0,GreenYellow))
                      {
                        Print("OrderModify 3 - Error # ",GetLastError()); //Modify 5.6.7 to include number 3
                        continue;
                      }
                      //GlobalVariableSet("FlagMode3Trade3",2);
                      return(0);
                  }
                if(OrderType()==OP_SELL)
                  {
                    NewSLTrade3S=OrderOpenPrice()-NormalizeDouble(((
                       OrderOpenPrice()-OrderTakeProfit())/2),Digits)+ MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
  			//Modified 5.6.8 by Daraknor, STOPLEVEL returns Point value. Adjusted value to price with *Point
                    //Added MarketInfo STOPLevel 5.6.6 by Daraknor to make the trades universally broker safe
                    if(NewSLTrade3S>=OrderStopLoss()) continue; //Added 5.6.7 by Daraknor, if new SL equal or worse old SL then quit.
  			  //5.6.8 by Daraknor changed to appropriate variable.
                    if(!OrderModify(OrderTicket(),OrderOpenPrice(),NewSLTrade3S,OrderTakeProfit(),0,GreenYellow))
                      {
                        Print("OrderModify 3 - Error # ",GetLastError()); //Modify 5.6.7 to include number 3
                        continue;
                      }
                     // GlobalVariableSet("FlagMode3Trade3",2);
                      return(0);
                  }
              }
          }
      }
  }

//+------------------------------------------------------------------+
//| START Function Close Trade 2 And 3 if Trade 1 is losing - Mode3  |
//+------------------------------------------------------------------+

void M3_D_CloseTrade23_If_Trd1_Loss()
  {

    bool CloseTrade=false;

    for(int x=OrdersTotal()-1; x>=0; x--)
      {
        if(!OrderSelect( x, SELECT_BY_POS))
          {
            Print("OrderSelect( ", x, ", SELECT_BY_POS ) - Error #",GetLastError());
            continue;
          }

        if((OrderSymbol() != Symbol()) || (OrderMagicNumber() != MAGICMA01)) continue;

        if(OrderType() == OP_BUY  && (OrderOpenPrice()-Bid > Point * P_Mode3_CloseTrade2_3)) {CloseTrade=true;}
        if(OrderType() == OP_SELL && (Ask-OrderOpenPrice() > Point * P_Mode3_CloseTrade2_3)) {CloseTrade=true;}

        if(CloseTrade)
          {
            for(int y = OrdersTotal() - 1; y >= 0; y --)
              {
                if(!OrderSelect( y, SELECT_BY_POS))
                  {
                    Print("OrderSelect( ", y, ", SELECT_BY_POS ) - Error #",GetLastError());
                    continue;
                  }

                if ((OrderMagicNumber() == MAGICMA02 || OrderMagicNumber() == MAGICMA03) && OrderSymbol()==Symbol())
                  {
                    if(OrderType() == OP_BUY)
                      {
                        if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet))
                          {
                            Print("Error OrderClose: ",GetLastError());
                            return(-1);
                          }
                        return(0);
                      }
                    if(OrderType() == OP_SELL)
                      {
                        if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet))
                          {
                            Print("Error OrderClose: ",GetLastError());
                            return(-1);
                          }
                        return(0);
                      }
                  }
              }
          }
      }
  }





//+------------------------------------------------------------------+
//+-------------  Shared Functions for PHOENIX  ---------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Open Trade If Signal for Mode 1 or Mode 2         |
//+------------------------------------------------------------------+
int S1_Mode_1_2_OpenTrade_If_Signal()
   {
   int Signal=0, err = 0, total = OrdersTotal();

   if(S2_Mode_ALL_NumberOfOpenOrder(Symbol()) < U_Mode12_MaxTrades)
      {
      if(Z_CheckSignal(Signal)==1)
         {
         if (CurTime()-W_s_time>900)
            {  //Added 5.6.4 Daraknor, Contributed Dagnar, Disable with a U_Mode12_ConsecutiveSignals=1
            W_Sell_Signal++;
            W_Buy_Signal=0;
            //W_s_time=CurTime(); //Uncomment here to make time check work. Default is tick based signals.
            }
         if (W_Sell_Signal>=U_Mode12_ConsecutiveSignals)
            {
            if(OrderSend(Symbol(),OP_SELL,Y_MM_OptimizeLotSize(),Bid,3,Bid+P_Mode12_StopLoss*Point,Bid-P_Mode12_TakeProfit*Point,"FirstTrade",MAGICMA_A,0,Red) < 0)
               {
               err = GetLastError();
               Print("Error Ordersend(",err,"): ");
               return(-1);
               }
            W_Sell_Signal=0;
            W_s_time=CurTime();     //comment this line and uncomment line above to make time based check work
            }
         return(0);
         }

      if(Z_CheckSignal(Signal)==2)
         {
         if (CurTime()-W_s_time>900)
            {  //Added 5.6.4 Daraknor, Contributed Dagnar, Disable with a U_Mode12_ConsecutiveSignals=1
            W_Buy_Signal++;
            W_Sell_Signal=0;
            //W_s_time=CurTime(); //Uncomment here to make time check work. Default is tick based signals.
            }
         if (W_Buy_Signal>=U_Mode12_ConsecutiveSignals)
            {
            if(OrderSend(Symbol(),OP_BUY,Y_MM_OptimizeLotSize(),Ask,3,Ask-P_Mode12_StopLoss*Point,Ask+P_Mode12_TakeProfit*Point,"FirstTrade",MAGICMA_A,0,Blue) < 0)
               {
               err = GetLastError();
               Print("Error Ordersend(",err,"): ");
               return(-1);
               }
            W_Buy_Signal=0;
            W_s_time=CurTime();
            }
         return(0);
         }
      }
   }

//+------------------------------------------------------------------+
//| START Function Number of Open Orders                             |
//+------------------------------------------------------------------+
int S2_Mode_ALL_NumberOfOpenOrder(string symbol)
  {
    int count=0;

    for(int i=0;i<OrdersTotal();i++)
      {
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
//      if(OrderSymbol()==Symbol() && (OrderMagicNumber()==MAGICMA_A || OrderMagicNumber()==MAGICMA_B))
        if(OrderSymbol()==symbol && (OrderMagicNumber()>=MAGICMA_A && OrderMagicNumber()<=MAGICMA03))
          {//5.7.0 made method generic
            count++;
          }
       }
    return(count);
  }


  
//+------------------------------------------------------------------+
//+-----  Functions for use in Any Expert Advisor  ------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| START Function Valid Trade Time                                  |
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------------------------------------+
//Define 2 period settings:
//- 1st period (a kind of grace period) after which a trade will be closed as soon as it is without a loss.
//              Technically by changing the TP setting to its price on entry (+spread?)
//              When this period has been reached, trades that are in profit will be closed immediately,
//              trades not yet in profit, will have time upto the next period to reach the breakeven point.
//
//- 2nd period after which the trade will be closed, regardless of its profit or loss status.
//+----------------------------------------------------------------------------------------------------------+

void X_ForceClose_or_GraceModify()
   {  //contributed by HerbertH in original Phoenix 2007 thread. Added and heavily modified by Daraknor 5.6.6

   int PeriodForce=U_PeriodForceHours*3600;
   int PeriodGrace=U_PeriodGraceHours*3600;

   RefreshRates(); //Added by Daraknor 5.6.6

   for(int i=0;i<OrdersTotal();i++)
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

      if (OrderSymbol()!=Symbol()) continue;
      if (OrderMagicNumber()>=MAGICMA_A && OrderMagicNumber()<=MAGICMA03 )
         {
         if (PeriodForce!=0)
            {
            if((OrderOpenTime() + PeriodForce) < Time[0])
               {
               if(OrderType() == OP_BUY)
                  {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
                  }
               if(OrderType() == OP_SELL)
                  {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
                  }
               }
            }
         if(PeriodGrace!=0)
            {
            if(OrderType() == OP_BUY)
               {
               if((OrderOpenTime() + PeriodGrace) < Time[0] && (OrderTakeProfit() > OrderOpenPrice()+(Ask-Bid)))
                  {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*P_Mode1_TrailingStop,OrderOpenPrice()+(Ask-Bid),0,GreenYellow);
                  }
               }
            if(OrderType() == OP_SELL)
               {
               if((OrderOpenTime() + PeriodGrace) < Time[0] && (OrderTakeProfit() > OrderOpenPrice()+(Ask-Bid)))
                  {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*P_Mode1_TrailingStop,OrderOpenPrice()-(Ask-Bid),0,GreenYellow);
                  }
               }
            }
         }
      }
   }



//+------------------------------------------------------------------+
//| START Close Trade After x Hours                                  |
//+------------------------------------------------------------------+

//  void X_Close_After_x_Hours()
//      {
//      int total = OrdersTotal();
//
//      for(int cnt=0;cnt<total;cnt++)
//         {
//         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
//         if(OrderType()<=OP_SELL &&
//            OrderSymbol()==Symbol() &&
//            OrderMagicNumber()==MAGICMA_A)
//            {
//            if((CurTime()-OrderOpenTime())>(U_CloseAfter_x_Hours*3600) && OrderProfit()<0)
//               {
//               OrderClose(OrderTicket(),OrderLots(),Bid,10,Violet);
//               }
//            }
//         }
//      }


//+------------------------------------------------------------------+
//| START MoneyManagement - Optimize lot size                        |
//+------------------------------------------------------------------+

double Y_MM_OptimizeLotSize()
  {
    if(U_MoneyManagement==false) return(U_Lots);

    double lot          =U_Lots;
    int    orders       =HistoryTotal();
    int    losses       =0;
    int    decimalPlaces=1;

    if(U_AccountIsMicro==true) decimalPlaces=2;

    lot=NormalizeDouble(AccountFreeMargin()*U_MaximumRisk/1000.0,decimalPlaces);
    if(U_DecreaseFactor>0)
      {
        for(int i=orders-1;i>=0;i--)
          {
            if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
            if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
            //----
            if(OrderProfit()>0) break;
            if(OrderProfit()<0) losses++;
          }
        if(losses>1) lot=NormalizeDouble(lot-lot*losses/U_DecreaseFactor,decimalPlaces);
      }

    if(lot<0.1 && U_AccountIsMicro==false) lot=0.1;
    if(lot<0.01 && U_AccountIsMicro==true) lot=0.01;
    if(lot>99) lot=99;

    return(lot);
  }


//+------------------------------------------------------------------+
//| START Function Z Check Signals                                   |
//+------------------------------------------------------------------+

//+ Note: If a siganl is used then it could be set to false or true
//+       If a signal is not used then it is always set to true
                             
//=====================SIGNAL1========================

int Z_CheckSignal(int Signal)
  {
    Signal=0;
    
    bool BuySignal1=false, SellSignal1=false;
    
    double HighEnvelope1 = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_UPPER,1);
    double LowEnvelope1  = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_LOWER,1);
    double CloseBar1     = iClose(NULL,0,1);
    
    if(U_UseSignal1)
      {
        if(CloseBar1 > HighEnvelope1) {SellSignal1 = true;}
        if(CloseBar1 < LowEnvelope1)  {BuySignal1  = true;}
      }
    else
      {
    	SellSignal1=true;
        BuySignal1= true;
      }


    //=====================SIGNAL2========================
    
    bool BuySignal2=false, SellSignal2=false;
    
    double SMA1=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
    double SMA2=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,P_SMA2Bars);
    
    if(U_UseSignal2)
      {
        if(SMA2-SMA1>0) {BuySignal2  = true;}
        if(SMA2-SMA1<0) {SellSignal2 = true;}
      }
    else
      {
    	SellSignal2=true;
        BuySignal2 =true;
      }

    
    //=====================SIGNAL3========================
    
    bool BuySignal3=false, SellSignal3=false;
    
    double OsMABar2=iOsMA(NULL,0,P_OSMASlow,P_OSMAFast,P_OSMASignal,PRICE_CLOSE,2);
    double OsMABar1=iOsMA(NULL,0,P_OSMASlow,P_OSMAFast,P_OSMASignal,PRICE_CLOSE,1);
    
    if(U_UseSignal3)
      {
        if(OsMABar2 > OsMABar1)  {SellSignal3 = true;}
        if(OsMABar2 < OsMABar1)  {BuySignal3  = true;}
      }
    else
      {
    	SellSignal3=true;
        BuySignal3 =true;
      }


    //=====================SIGNAL4========================  
    
       double diverge;
       bool BuySignal4=false,SellSignal4=false;
       
       diverge = Z_S4_Divergence(P_Fast_Period, P_Slow_Period, P_Fast_Price, P_Slow_Price,0);
    
    if(U_UseSignal4)
      {
        if(diverge >= P_DVBuySell && diverge <= P_DVStayOut)
          {BuySignal4  = true;}
        if(diverge <= (P_DVBuySell*(-1)) && diverge >= (P_DVStayOut*(-1)))
          {SellSignal4 = true;}
      }
    else
      {
    	SellSignal4=true;
        BuySignal4 =true;
      }

        
    //=====================SIGNAL5=======================  
    
    bool BuySignal5=false, SellSignal5=false;
    
    if(U_UseSignal5)
      {
        int iHour=TimeHour(LocalTime());
        int ValidTradeTime = Z_S5_ValidTradeTime(iHour);

        if(ValidTradeTime==true)
          {
            BuySignal5 =true;
            SellSignal5=true;
          }
      }
    else
      {
    	SellSignal3=true;
        BuySignal3 =true;
      }

    if((SellSignal1==true) && (SellSignal2==true) && (SellSignal3==true) && (SellSignal4==true) && (SellSignal5==true)) return(1);  
    if((BuySignal1==true)  && (BuySignal2==true)  && (BuySignal3==true)  && (BuySignal4==true)  && (BuySignal5==true))  return(2);
  }

//+------------------------------------------------------------------+
//| START Function Diverge                                           |
//+------------------------------------------------------------------+

double Z_S4_Divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
    int i;
    double maF1, maF2, maS1, maS2;

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);

    return(maF2-maS2);
  }



//+------------------------------------------------------------------+
//| START Function Valid Trade Time                                  |
//+------------------------------------------------------------------+
bool Z_S5_ValidTradeTime (int iHour)
   {
      if(((iHour >= U_TradeFrom1) && (iHour <= (U_TradeUntil1-1)))||((iHour>= U_TradeFrom2) && (iHour <= (U_TradeUntil2-1)))||((iHour >= U_TradeFrom3)&& (iHour <= (U_TradeUntil3-1)))||((iHour >= U_TradeFrom4) && (iHour <=(U_TradeUntil4-1))))
      {
         return (true);
      }
      else
         return (false);
   }  

